﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;

namespace WF4Host
{
    public class PropertyViewPresenter:Grid
    {

        public HostingHelper HostingHelper
        {
            get { return (HostingHelper)GetValue(HostingHelperProperty); }
            set { SetValue(HostingHelperProperty, value); }
        }

        public static readonly DependencyProperty HostingHelperProperty =
            DependencyProperty.Register("HostingHelper", typeof(HostingHelper), typeof(PropertyViewPresenter), new UIPropertyMetadata(null, new PropertyChangedCallback(OnHostingHelperChanged)));

        protected static void OnHostingHelperChanged(DependencyObject dobj
            , DependencyPropertyChangedEventArgs dpcea)
        {
            if (dobj is PropertyViewPresenter)
            {
                var mvp = dobj as PropertyViewPresenter;
                mvp.Children.Clear();
                if (dpcea.NewValue != null)
                {
                    var host = dpcea.NewValue as HostingHelper;
                    host.Designer.PropertyInspectorView.SetValue(Panel.HorizontalAlignmentProperty, HorizontalAlignment.Stretch);
                    host.Designer.PropertyInspectorView.SetValue(Panel.VerticalAlignmentProperty, VerticalAlignment.Stretch);
                    mvp.Children.Add(host.Designer.PropertyInspectorView);
                }
            }
        }
    }
}
